# class CSV::Parser

- CSV::Parser
- Reference
- Object

##
Overview

A CSV parser. It lets you consume a CSV row by row.

Most of the time `CSV#parse` and `CSV#each_row` are more convenient.

##
Defined in:

csv/parser.cr

##
Constructors

- .new(string_or_io : String | IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR)

  Creates a parser from a `String` or `IO`.

##
Instance Method Summary

- #each_row(&) : Nil

  Yields each of the remaining rows as an `Array(String)`.

- #each_row : Iterator(Array(String))

  Returns an `Iterator` of `Array(String)` for the remaining rows.

- #next_row(array : Array(String)) : Array(String) | Nil

  Reads the next row into the given array.

- #next_row : Array(String) | Nil

  Returns the next row in the CSV, if any, or `nil`.

- #parse : Array(Array(String))

  Returns the remaining rows.

- #rewind : Nil

  Rewinds this parser to the beginning.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, initialize initialize, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference) : Bool
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new, unsafe_construct(address : Pointer, *args, **opts) : self unsafe_construct

### Class methods inherited from class `Reference`

pre_initialize(address : Pointer) pre_initialize

### Instance methods inherited from class `Object`

! : Bool !, !=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, as(type : Class) as, as?(type : Class) as?, class class, dup dup, hash(hasher)
hash hash, in?(collection : Object) : Bool
in?(*values : Object) : Bool in?, inspect(io : IO) : Nil
inspect : String inspect, is_a?(type : Class) : Bool is_a?, itself itself, nil? : Bool nil?, not_nil!(message)
not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, responds_to?(name : Symbol) : Bool responds_to?, tap(&) tap, to_json(io : IO) : Nil
to_json : String to_json, to_pretty_json(indent : String = " ") : String
to_pretty_json(io : IO, indent : String = " ") : Nil to_pretty_json, to_s(io : IO) : Nil
to_s : String to_s, to_yaml(io : IO) : Nil
to_yaml : String to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io : String | IO, root : String)
from_json(string_or_io : String | IO) from_json, from_yaml(string_or_io : String | IO) from_yaml

### Macros inherited from class `Object`

class_getter(*names, &block) class_getter, class_getter!(*names) class_getter!, class_getter?(*names, &block) class_getter?, class_property(*names, &block) class_property, class_property!(*names) class_property!, class_property?(*names, &block) class_property?, class_setter(*names) class_setter, def_clone def_clone, def_equals(*fields) def_equals, def_equals_and_hash(*fields) def_equals_and_hash, def_hash(*fields) def_hash, delegate(*methods, to object) delegate, forward_missing_to(delegate) forward_missing_to, getter(*names, &block) getter, getter!(*names) getter!, getter?(*names, &block) getter?, property(*names, &block) property, property!(*names) property!, property?(*names, &block) property?, setter(*names) setter

##
Constructor Detail

def self.new(string_or_io : String | IO, separator : Char = DEFAULT_SEPARATOR, quote_char : Char = DEFAULT_QUOTE_CHAR) #

Creates a parser from a `String` or `IO`. Optionally takes the optional separator and quote_char arguments for specifying non-standard cell separators and quote characters

##
Instance Method Detail

def each_row(&) : Nil #

Yields each of the remaining rows as an `Array(String)`.

def each_row : Iterator(Array(String)) #

Returns an `Iterator` of `Array(String)` for the remaining rows.

def next_row(array : Array(String)) : Array(String) | Nil #

Reads the next row into the given array. Returns that same array, if a row was found, or `nil`.

def next_row : Array(String) | Nil #

Returns the next row in the CSV, if any, or `nil`.

def parse : Array(Array(String)) #

Returns the remaining rows.

def rewind : Nil #

Rewinds this parser to the beginning.